capture program drop longterm_crossclass_table
program define longterm_crossclass_table

	version 11
	syntax varlist [if], controls(varlist) [output(string) r_suffix(string) tv_var(varname) replace append noresid vce(string) robust cluster(varname) postresid_if(string) notvinsample]
	
	estimates clear
	
	if ("`tvinsample'"!="notvinsample") local tv_insample="tv_insample"
	if ("`tv_var'"=="") local tv_var="tv_sd"
	if ("`cluster'"=="") & ("`robust'"=="") & ("`vce'"=="") local cluster="sch_cohort"
	if (`"`postresid_if'"'!="") {
		if (`"`if'"'!="") local postresid_if `"& `postresid_if'"'
		else local postresid_if `"if `postresid_if'"'
	}
	
	if (`"`output'"'!="") {
		file open _longterm_cc using `"`output'"', write text `replace' `append'
		if ("`replace'"!="") file write _longterm_cc "`tv_var',coeff,se,p val,N,yvar mean,weighted N,if cond" _n
	}
	
	foreach var of varlist `varlist' {
		if ("`resid'"!="noresid") residualize_middle_math `var'_r`r_suffix'=`var' `if', `tv_insample' controls(`controls')
		
		if (`"`output'"'!="") file write _longterm_cc "`var'_r`r_suffix',"
		
		qui reg `var'_r`r_suffix' `tv_var' middle math middle_math `if' `postresid_if' [w=`var'_count], vce(`vce') `robust' cluster(`cluster')
		
		if (`"`output'"'!="") file write _longterm_cc (_b[`tv_var']) "," (_se[`tv_var']) "," (2 * ttail(e(df_r), abs(_b[`tv_var']/_se[`tv_var']))) "," (e(N)) ","
		di "`var': coeff  " _b[`tv_var'] "  s.e.  "  _se[`tv_var'] "  p-val  " (2 * ttail(e(df_r), abs(_b[`tv_var']/_se[`tv_var']))) " N: " e(N)
		
		qui sum `var' [w=`var'_count] if e(sample)
		if (`"`output'"'!="") file write _longterm_cc (r(mean)) "," (r(sum_w)) ","
		di "`var' mean:  " r(mean) _n "numobs `var':" r(sum_w)
		
		if (`"`output'"'!="") file write _longterm_cc "`if'" _n
	}
	
	if (`"`output'"'!="") file close _longterm_cc

end
