capture program drop residualize_middle_math
program define residualize_middle_math

	version 11
	syntax newvarname=/exp [if/], [tv_insample noWEIGHTs controls(varlist)]
	
	if ("`if'"!="") local if `if' &
	if ("`controls'"=="") local controls ${controls}
	
	if ("`tv_insample'"=="tv_insample") local insample_cond="tv_insample==1 &"
	if ("`weights'"!="noweights") local wt="[w="+trim("`exp'")+"_count]"
	
	tempvar resid
	qui gen double `varlist'=.
	
	forvalues middle=0/1 {
		forvalues math=0/1 {
			qui count if `if' `insample_cond' middle==`middle' & math==`math' & !missing(`exp')
			if (r(N)>0) {
				qui areg `exp' `controls' `wt' if `if' `insample_cond' middle==`middle' & math==`math', a(teacher)
				qui predict `resid' if e(sample), dr
				qui replace `varlist'=`resid' if e(sample)
				drop `resid'
			}
		}
	}
end
